(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/cdk/table'), require('@angular/core'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-base-angular-store', ['exports', 'rxjs', '@angular/cdk/table', '@angular/core', 'rxjs/operators'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-base-angular-store'] = {}), global.rxjs, global.ng.cdk.table, global.ng.core, global.rxjs.operators));
}(this, (function (exports, rxjs, table, core, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    const __createBinding = Object.create ? (function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
    }) : (function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    });

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    const __setModuleDefault = Object.create ? (function(o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function(o, v) {
        o["default"] = v;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    //import { ErrorDialog } from '../error/error-dialog.component';
    /** @type {?} */
    var TAG = 'TableDataSource';
    /**
     * @abstract
     * @template E
     */
    var   /**
     * @abstract
     * @template E
     */
    TableDataSource = /** @class */ (function (_super) {
        __extends(TableDataSource, _super);
        function TableDataSource() {
            //errorSubject: BehaviorSubject<Error> = new BehaviorSubject<Error>();
            var _this = _super !== null && _super.apply(this, arguments) || this;
            //statusEvent = new EventEmitter<string>();
            _this.errorEvent = new core.EventEmitter();
            _this.showSpinner = true;
            return _this;
        }
        /**
         *  Called when the table is being destroyed. Use this function, to clean up
         * any open connections or free any held resources that were set up during connect.
         */
        /**
         *  Called when the table is being destroyed. Use this function, to clean up
         * any open connections or free any held resources that were set up during connect.
         * @return {?}
         */
        TableDataSource.prototype.disconnect = /**
         *  Called when the table is being destroyed. Use this function, to clean up
         * any open connections or free any held resources that were set up during connect.
         * @return {?}
         */
        function () {
            if (this.errorEvent)
                this.errorEvent.complete();
        };
        /**
         * overload to provide post load filtering
         */
        // noinspection JSMethodCanBeStatic
        /**
         * overload to provide post load filtering
         * @protected
         * @param {?} data
         * @return {?}
         */
        // noinspection JSMethodCanBeStatic
        TableDataSource.prototype.filterData = /**
         * overload to provide post load filtering
         * @protected
         * @param {?} data
         * @return {?}
         */
        // noinspection JSMethodCanBeStatic
        function (data) {
            return data;
        };
        // noinspection JSMethodCanBeStatic
        // noinspection JSMethodCanBeStatic
        /**
         * @protected
         * @param {?} filter
         * @param {?} paginator
         * @return {?}
         */
        TableDataSource.prototype.applyPaginator = 
        // noinspection JSMethodCanBeStatic
        /**
         * @protected
         * @param {?} filter
         * @param {?} paginator
         * @return {?}
         */
        function (filter, paginator) {
            if (filter && paginator) {
                filter.pager = {
                    firstResult: (paginator.pageIndex || 0) * paginator.pageSize,
                    pageSize: paginator.pageSize
                };
            }
        };
        // noinspection JSMethodCanBeStatic
        // noinspection JSMethodCanBeStatic
        /**
         * @protected
         * @param {?} filter
         * @param {?} sort
         * @return {?}
         */
        TableDataSource.prototype.applySort = 
        // noinspection JSMethodCanBeStatic
        /**
         * @protected
         * @param {?} filter
         * @param {?} sort
         * @return {?}
         */
        function (filter, sort) {
            if (filter) {
                if (sort && sort.active) {
                    filter.orderDir = sort.direction ? sort.direction.toUpperCase() : "ASC";
                    filter.orderBy = sort.active;
                }
                if (filter.orderBy) {
                    filter.orderBy = filter.orderBy.trim();
                    if (filter.orderBy == '')
                        delete filter.orderBy;
                }
            }
        };
        // noinspection JSMethodCanBeStatic
        // noinspection JSMethodCanBeStatic
        /**
         * @protected
         * @param {?} filter
         * @param {?=} value
         * @return {?}
         */
        TableDataSource.prototype.applyKeyword = 
        // noinspection JSMethodCanBeStatic
        /**
         * @protected
         * @param {?} filter
         * @param {?=} value
         * @return {?}
         */
        function (filter, value) {
            if (filter && value) {
                filter.keyword = value;
            }
        };
        /**
         * @protected
         * @param {?} e
         * @param {?=} op
         * @param {?=} component
         * @return {?}
         */
        TableDataSource.prototype.onError = /**
         * @protected
         * @param {?} e
         * @param {?=} op
         * @param {?=} component
         * @return {?}
         */
        function (e, op, component) {
            if (component === void 0) { component = this.constructor.name; }
            this.status = 'error';
            e.error = Object.assign({ operation: op, component: component }, e.error);
            console.warn(TAG, 'Error loading data', op, e);
            this.errorEvent.emit(e);
        };
        return TableDataSource;
    }(table.DataSource));
    if (false) {
        /** @type {?} */
        TableDataSource.prototype.status;
        /** @type {?} */
        TableDataSource.prototype.errorEvent;
        /** @type {?} */
        TableDataSource.prototype.showSpinner;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    //import {FilteredTableSource} from "./filtered-table-source";
    //import {finalize} from "rxjs/operators";
    /** @type {?} */
    var TAG$1 = 'MatTableSource';
    /**
     * @abstract
     * @template E
     */
    var   /**
     * @abstract
     * @template E
     */
    MatTableSource = /** @class */ (function (_super) {
        __extends(MatTableSource, _super);
        function MatTableSource(paginator, sort) {
            var _this = _super.call(this) || this;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.dataList = [];
            _this.status = 'loading';
            return _this;
        }
        /**
         * @return data mutations which trigger table reload
         */
        /**
         * @protected
         * @return {?} data mutations which trigger table reload
         */
        MatTableSource.prototype.initReloadMutations = /**
         * @protected
         * @return {?} data mutations which trigger table reload
         */
        function () {
            /** @type {?} */
            var dataMutations = [];
            if (this.paginator)
                dataMutations.push(this.paginator.page);
            if (this.sort)
                dataMutations.push(this.sort.sortChange);
            return dataMutations;
        };
        /**
         * @param totalRows total number of rows (without paging)
         */
        /**
         * @protected
         * @param {?} totalRows total number of rows (without paging)
         * @return {?}
         */
        MatTableSource.prototype.updatePager = /**
         * @protected
         * @param {?} totalRows total number of rows (without paging)
         * @return {?}
         */
        function (totalRows) {
            if (this.paginator) {
                this.paginator.length = totalRows;
            }
        };
        /**
         * Connect this data source to the table. The table will only update when
         * the returned stream emits new items.
         * @returns A stream of the items to be rendered.
         */
        /**
         * Connect this data source to the table. The table will only update when
         * the returned stream emits new items.
         * @return {?} A stream of the items to be rendered.
         */
        MatTableSource.prototype.connect = /**
         * Connect this data source to the table. The table will only update when
         * the returned stream emits new items.
         * @return {?} A stream of the items to be rendered.
         */
        function () {
            var _this = this;
            // Combine everything that affects the rendered data into one update
            // stream for the data-table to consume.
            /** @type {?} */
            var dataMutations = this.initReloadMutations();
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                rxjs.merge.apply(void 0, __spread(dataMutations)).subscribe((/**
                 * @return {?}
                 */
                function () {
                    _this.reloadTable().subscribe((/**
                     * @param {?} rows
                     * @return {?}
                     */
                    function (rows) {
                        if (_this.dataList.length == 0)
                            _this.dataList = rows;
                        observer.next(_this.filterData(rows));
                    }));
                }));
            }));
        };
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        MatTableSource.prototype.pageData = /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        function (data) {
            if (this.paginator != null) {
                this.paginator.length = data.length;
                /** @type {?} */
                var startIndex = this.paginator.pageIndex * this.paginator.pageSize;
                data = data.splice(startIndex, this.paginator.pageSize);
            }
            return data;
        };
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        MatTableSource.prototype.sortData = /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        function (data) {
            var _this = this;
            if (!this.sort || !this.sort.active || this.sort.direction == '') {
                return data;
            }
            return data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                var _a;
                /** @type {?} */
                var propertyA;
                /** @type {?} */
                var propertyB;
                /** @type {?} */
                var prop = _this.sort.active;
                //[propertyA, propertyB] = [a[prop], b[prop]];
                _a = __read(_this.sortValues(a, b, prop), 2), propertyA = _a[0], propertyB = _a[1];
                /** @type {?} */
                var valueA = isNaN(+propertyA) ? propertyA : +propertyA;
                /** @type {?} */
                var valueB = isNaN(+propertyB) ? propertyB : +propertyB;
                return (valueA < valueB ? -1 : 1) * (_this.sort.direction == 'asc' ? 1 : -1);
            }));
        };
        /**
         * @protected
         * @param {?} a
         * @param {?} b
         * @param {?} prop
         * @return {?}
         */
        MatTableSource.prototype.sortValues = /**
         * @protected
         * @param {?} a
         * @param {?} b
         * @param {?} prop
         * @return {?}
         */
        function (a, b, prop) {
            return [a[prop], b[prop]];
        };
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        MatTableSource.prototype.searchData = /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        function (data) {
            return data;
        };
        return MatTableSource;
    }(TableDataSource));
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        MatTableSource.prototype.dataList;
        /**
         * @type {?}
         * @protected
         */
        MatTableSource.prototype.paginator;
        /**
         * @type {?}
         * @protected
         */
        MatTableSource.prototype.sort;
        /**
         * reload table data
         * @abstract
         * @protected
         * @return {?}
         */
        MatTableSource.prototype.reloadTable = function () { };
    }
    /**
     * @abstract
     * @template E
     */
    var   /**
     * @abstract
     * @template E
     */
    MixMatTableSource = /** @class */ (function (_super) {
        __extends(MixMatTableSource, _super);
        function MixMatTableSource(paginator, sort) {
            var _this = _super.call(this, paginator, sort) || this;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.autoLoad = true;
            _this.dataSubject = new rxjs.BehaviorSubject(null);
            return _this;
        }
        /**
         * @return {?}
         */
        MixMatTableSource.prototype.connect = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.serverMutations = this.initReloadMutations();
            if (this.serverMutations.length > 0) {
                rxjs.merge.apply(void 0, __spread(this.serverMutations)).subscribe((/**
                 * @return {?}
                 */
                function () { return _this.reload(); }));
            }
            else {
                console.debug(TAG$1, "connect: autoLoad", this.autoLoad);
                if (this.autoLoad) {
                    this.reload();
                }
            }
            /** @type {?} */
            var dataMutations = this.initDisplayMutations();
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                rxjs.merge.apply(void 0, __spread(dataMutations)).subscribe((/**
                 * @return {?}
                 */
                function () {
                    if (_this.dataSubject.value)
                        observer.next(_this.filterData(_this.dataSubject.value.slice()));
                }));
            }));
        };
        /**
         * @return {?}
         */
        MixMatTableSource.prototype.disconnect = /**
         * @return {?}
         */
        function () {
            if (this.dataSubject != null)
                this.dataSubject.complete();
            _super.prototype.disconnect.call(this);
        };
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        MixMatTableSource.prototype.filterData = /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        function (data) {
            /** @type {?} */
            var origLength = data.length;
            /** @type {?} */
            var serverMutations = this.serverMutations;
            // if(this.filterSubject && serverMutations.indexOf(this.filterSubject) == -1)
            //   data = this.searchData(data);
            if (this.sort && serverMutations.indexOf(this.sort.sortChange) == -1)
                data = this.sortData(data);
            if (this.paginator && serverMutations.indexOf(this.paginator.page) == -1)
                data = this.pageData(data);
            console.debug(TAG$1, "filterData:", data.length, "/", origLength);
            return data;
        };
        /**
         * @return {?}
         */
        MixMatTableSource.prototype.reload = /**
         * @return {?}
         */
        function () {
            var _this = this;
            console.debug(TAG$1, "reload");
            this.status = 'loading';
            this.reloadTable()
                //.pipe(finalize(() => this.status = 'ready'))
                .subscribe((/**
             * @param {?} rows
             * @return {?}
             */
            function (rows) { return _this.onLoaded(rows); }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return _this.onError(error, 'reload'); }));
        };
        /**
         * @protected
         * @param {?} rows
         * @return {?}
         */
        MixMatTableSource.prototype.onLoaded = /**
         * @protected
         * @param {?} rows
         * @return {?}
         */
        function (rows) {
            this.status = 'ready';
            this.dataSubject.next(rows);
        };
        /**
         * overload to setup server side mutations.
         */
        /**
         * overload to setup server side mutations.
         * @protected
         * @return {?}
         */
        MixMatTableSource.prototype.initReloadMutations = /**
         * overload to setup server side mutations.
         * @protected
         * @return {?}
         */
        function () {
            return this.findAllMutations();
        };
        /**
         * @protected
         * @return {?}
         */
        MixMatTableSource.prototype.findAllMutations = /**
         * @protected
         * @return {?}
         */
        function () {
            return _super.prototype.initReloadMutations.call(this);
        };
        /**
         * @protected
         * @return {?}
         */
        MixMatTableSource.prototype.initClientMutations = /**
         * @protected
         * @return {?}
         */
        function () {
            // remove server side mutations
            /** @type {?} */
            var remove = this.serverMutations;
            /** @type {?} */
            var dataMutations = this.findAllMutations();
            return dataMutations.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                return remove.indexOf(item) === -1;
            }));
        };
        /**
         * @protected
         * @return {?}
         */
        MixMatTableSource.prototype.initDisplayMutations = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var dataMutations = [this.dataSubject];
            dataMutations = dataMutations.concat(this.initClientMutations());
            return dataMutations;
        };
        // protected applyFilter(filter : F) {
        //   if(this.paginator && this.serverMutations.indexOf(this.paginator.page) != -1)
        //     this.applyPaginator(filter, this.paginator);
        //   if(this.sort && this.serverMutations.indexOf(this.sort.sortChange) != -1)
        //     this.applySort(filter, this.sort);
        //   this.applyKeyword(filter);
        // }
        // protected applyFilter(filter : F) {
        //   if(this.paginator && this.serverMutations.indexOf(this.paginator.page) != -1)
        //     this.applyPaginator(filter, this.paginator);
        //   if(this.sort && this.serverMutations.indexOf(this.sort.sortChange) != -1)
        //     this.applySort(filter, this.sort);
        //   this.applyKeyword(filter);
        // }
        /**
         * @protected
         * @param {?} filter
         * @param {?} paginator
         * @return {?}
         */
        MixMatTableSource.prototype.applyPaginator = 
        // protected applyFilter(filter : F) {
        //   if(this.paginator && this.serverMutations.indexOf(this.paginator.page) != -1)
        //     this.applyPaginator(filter, this.paginator);
        //   if(this.sort && this.serverMutations.indexOf(this.sort.sortChange) != -1)
        //     this.applySort(filter, this.sort);
        //   this.applyKeyword(filter);
        // }
        /**
         * @protected
         * @param {?} filter
         * @param {?} paginator
         * @return {?}
         */
        function (filter, paginator) {
            if (paginator && this.serverMutations.indexOf(paginator.page) != -1)
                _super.prototype.applyPaginator.call(this, filter, paginator);
        };
        /**
         * @protected
         * @param {?} filter
         * @param {?} sort
         * @return {?}
         */
        MixMatTableSource.prototype.applySort = /**
         * @protected
         * @param {?} filter
         * @param {?} sort
         * @return {?}
         */
        function (filter, sort) {
            if (sort && this.serverMutations.indexOf(sort.sortChange) != -1)
                _super.prototype.applySort.call(this, filter, sort);
        };
        /**
         * @param {?} paginator
         * @return {?}
         */
        MixMatTableSource.prototype.setPaginator = /**
         * @param {?} paginator
         * @return {?}
         */
        function (paginator) {
            this.paginator = paginator;
        };
        /**
         * @param {?} sort
         * @return {?}
         */
        MixMatTableSource.prototype.setSort = /**
         * @param {?} sort
         * @return {?}
         */
        function (sort) {
            this.sort = sort;
        };
        return MixMatTableSource;
    }(MatTableSource));
    if (false) {
        /** @type {?} */
        MixMatTableSource.prototype.dataSubject;
        /**
         * @type {?}
         * @protected
         */
        MixMatTableSource.prototype.serverMutations;
        /**
         * @type {?}
         * @protected
         */
        MixMatTableSource.prototype.autoLoad;
        /**
         * @type {?}
         * @protected
         */
        MixMatTableSource.prototype.paginator;
        /**
         * @type {?}
         * @protected
         */
        MixMatTableSource.prototype.sort;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TAG$2 = 'FilteredTableSource';
    /**
     * @abstract
     * @template F, E
     */
    var   /**
     * @abstract
     * @template F, E
     */
    FilteredTableSource = /** @class */ (function (_super) {
        __extends(FilteredTableSource, _super);
        function FilteredTableSource(paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort) || this;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        /**
         * @return {?}
         */
        FilteredTableSource.prototype.disconnect = /**
         * @return {?}
         */
        function () {
            if (this.filterSubject != null)
                this.filterSubject.complete();
            _super.prototype.disconnect.call(this);
        };
        /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        FilteredTableSource.prototype.applyFilter = /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            this.applyPaginator(filter, this.paginator);
            this.applySort(filter, this.sort);
            this.applyKeyword(filter);
        };
        /**
         * @protected
         * @return {?}
         */
        FilteredTableSource.prototype.findAllMutations = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var mutations = _super.prototype.findAllMutations.call(this);
            if (this.filterSubject)
                mutations.push(this.filterSubject);
            //console.debug(TAG, "findAllMutations: mutations", mutations.length);
            return mutations;
        };
        /**
         * @protected
         * @return {?}
         */
        FilteredTableSource.prototype.findFilter = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var filter = this.filterSubject.value;
            if (!filter) {
                filter = (/** @type {?} */ ({}));
            }
            return filter;
        };
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        FilteredTableSource.prototype.filterData = /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        function (data) {
            /** @type {?} */
            var serverMutations = this.serverMutations;
            //console.debug(TAG, "filterData: serverMutations", serverMutations);
            if (this.filterSubject && serverMutations.indexOf(this.filterSubject) == -1)
                data = this.searchData(data);
            return _super.prototype.filterData.call(this, data);
        };
        return FilteredTableSource;
    }(MixMatTableSource));
    if (false) {
        /** @type {?} */
        FilteredTableSource.prototype.filterSubject;
        /**
         * @type {?}
         * @protected
         */
        FilteredTableSource.prototype.paginator;
        /**
         * @type {?}
         * @protected
         */
        FilteredTableSource.prototype.sort;
        /**
         * @type {?}
         * @protected
         */
        FilteredTableSource.prototype.tableFilter;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    //import {MatPaginator} from "@angular/material/paginator";
    //import {MatSort} from "@angular/material/sort";
    /** @type {?} */
    var TAG$3 = 'QueryTableSource';
    /**
     * Data source for QueryResult objects
     * (including sorting, pagination, and filtering).
     * @abstract
     * @template F, E
     */
    var   /**
     * Data source for QueryResult objects
     * (including sorting, pagination, and filtering).
     * @abstract
     * @template F, E
     */
    QueryTableSource = /** @class */ (function (_super) {
        __extends(QueryTableSource, _super);
        function QueryTableSource() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @protected
         * @return {?}
         */
        QueryTableSource.prototype.reloadTable = /**
         * @protected
         * @return {?}
         */
        function () {
            var _this = this;
            return this.queryTable().pipe(operators.map((/**
             * @param {?} qr
             * @return {?}
             */
            function (qr) {
                _this.updatePager(qr.rows);
                return qr.items;
            })));
        };
        return QueryTableSource;
    }(FilteredTableSource));
    if (false) {
        /**
         * query table data
         * @abstract
         * @protected
         * @return {?}
         */
        QueryTableSource.prototype.queryTable = function () { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TAG$4 = 'SearchTableSource';
    /**
     * Data source for SearchResult objects
     * (including sorting, pagination, and filtering).
     * @abstract
     * @template F, E
     */
    var   /**
     * Data source for SearchResult objects
     * (including sorting, pagination, and filtering).
     * @abstract
     * @template F, E
     */
    SearchTableSource = /** @class */ (function (_super) {
        __extends(SearchTableSource, _super);
        function SearchTableSource() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @protected
         * @return {?}
         */
        SearchTableSource.prototype.reloadTable = /**
         * @protected
         * @return {?}
         */
        function () {
            var _this = this;
            return this.searchTable().pipe(operators.map((/**
             * @param {?} qr
             * @return {?}
             */
            function (qr) {
                _this.updatePager(qr.total);
                return qr.rows;
            })));
        };
        return SearchTableSource;
    }(FilteredTableSource));
    if (false) {
        /**
         * query table data
         * @abstract
         * @protected
         * @return {?}
         */
        SearchTableSource.prototype.searchTable = function () { };
    }

    exports.FilteredTableSource = FilteredTableSource;
    exports.MatTableSource = MatTableSource;
    exports.MixMatTableSource = MixMatTableSource;
    exports.QueryTableSource = QueryTableSource;
    exports.SearchTableSource = SearchTableSource;
    exports.TableDataSource = TableDataSource;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-base-angular-store.umd.js.map
