import { BehaviorSubject } from "rxjs";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { MixMatTableSource } from "./mat-table-source";
import { TableFilter } from "@yukawa/chain-base-angular-domain";
export declare abstract class FilteredTableSource<F extends TableFilter | any, E> extends MixMatTableSource<E> {
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: F;
    filterSubject: BehaviorSubject<F>;
    protected constructor(paginator?: MatPaginator, sort?: MatSort, tableFilter?: F);
    disconnect(): void;
    protected applyFilter(filter: F): void;
    protected findAllMutations(): any[];
    protected findFilter(): F;
    protected filterData(data: E[]): E[];
}
